searchData={"items":[{"type":"module","title":"ATECC508A","doc":"The ATECC508A is an authentication device used for storing private keys\nand other data securely.","ref":"ATECC508A.html"},{"type":"type","title":"ATECC508A.cert_serial_number/0","doc":"ATECC508A compressed certificates have 16-byte serial numbers","ref":"ATECC508A.html#t:cert_serial_number/0"},{"type":"type","title":"ATECC508A.compressed_cert/0","doc":"Microchip P256 compressed certificate\n\nSee Atmel-8974A app note","ref":"ATECC508A.html#t:compressed_cert/0"},{"type":"type","title":"ATECC508A.crc16/0","doc":"A CRC16 as computed by the ATECC508A","ref":"ATECC508A.html#t:crc16/0"},{"type":"type","title":"ATECC508A.ecc_public_key/0","doc":"An ECC P256 public key","ref":"ATECC508A.html#t:ecc_public_key/0"},{"type":"type","title":"ATECC508A.encoded_dates/0","doc":"ATECC508A compressed certificates use a 3-byte encoding for the validity date range.","ref":"ATECC508A.html#t:encoded_dates/0"},{"type":"type","title":"ATECC508A.serial_number/0","doc":"This represents the ATECC508A 9-byte device serial number","ref":"ATECC508A.html#t:serial_number/0"},{"type":"type","title":"ATECC508A.sha256/0","doc":"A SHA256 hash","ref":"ATECC508A.html#t:sha256/0"},{"type":"type","title":"ATECC508A.sn_source/0","doc":"The serial number source for a compressed certificate","ref":"ATECC508A.html#t:sn_source/0"},{"type":"module","title":"ATECC508A.Certificate","doc":"Convert between X.509 certificates and ATECC508A compressed certificates\n\nThis is an implementation of the compressed certificate definition described in\nAtmel-8974A-CryptoAuth-ATECC-Compressed-Certificate-Definition-ApplicationNote_112015.","ref":"ATECC508A.Certificate.html"},{"type":"function","title":"ATECC508A.Certificate.compress/2","doc":"Compress an X.509 certificate for storage in an ATECC508A slot.\n\nNot all X.509 certificates are compressible. Most aren't. It's probably\nonly practical to go through `new_device` and `new_signer`.\n\nParameters:\n\n* `cert` - the certificate to compress\n* `template` - the template that will be used on the decompression side","ref":"ATECC508A.Certificate.html#compress/2"},{"type":"function","title":"ATECC508A.Certificate.compress_signature/1","doc":"Compress an X.509 signature into the raw format expected on the ECC508A","ref":"ATECC508A.Certificate.html#compress_signature/1"},{"type":"function","title":"ATECC508A.Certificate.compress_validity/1","doc":"","ref":"ATECC508A.Certificate.html#compress_validity/1"},{"type":"function","title":"ATECC508A.Certificate.curve/0","doc":"","ref":"ATECC508A.Certificate.html#curve/0"},{"type":"function","title":"ATECC508A.Certificate.decompress/1","doc":"Decompress an ECC508A certificate back to it's X.509 form.","ref":"ATECC508A.Certificate.html#decompress/1"},{"type":"function","title":"ATECC508A.Certificate.decompress_signature/1","doc":"Decompress an ECC508A signature into X.509 form.","ref":"ATECC508A.Certificate.html#decompress_signature/1"},{"type":"function","title":"ATECC508A.Certificate.decompress_validity/2","doc":"","ref":"ATECC508A.Certificate.html#decompress_validity/2"},{"type":"function","title":"ATECC508A.Certificate.get_authority_key_identifier/1","doc":"","ref":"ATECC508A.Certificate.html#get_authority_key_identifier/1"},{"type":"function","title":"ATECC508A.Certificate.hash/0","doc":"","ref":"ATECC508A.Certificate.html#hash/0"},{"type":"function","title":"ATECC508A.Certificate.new_device/5","doc":"Create a new device certificate.\n\nThe created certificate is compatible with ATECC508A certificate compression.\n\nParameters:\n\n* `atecc508a_public_key` - the public key to be signed (from ATECC508A)\n* `atecc508a_sn` - the ATECC508a's serial number - used to compute the certificate's serial number\n* `manufacturer_sn` - the manufacturer's desired serial number - used as the common name\n* `signer` - the signer's certificate\n* `signer_key` - the signer's private key","ref":"ATECC508A.Certificate.html#new_device/5"},{"type":"function","title":"ATECC508A.Certificate.new_signer/1","doc":"Create a new signer certificate.\n\nThe signer certificate is a root certificate. I.e. it's not signed by\nanyone else. Signer certificates and their associated private keys\nshould be stored safely, though. Their overall use is limited to automating\nthe registration of devices to cloud servers like Nerves Hub and\nAmazon IoT. Once a device has registered, the cloud server will\nignore the signer certificate. It is therefore possible to time limit\nsigner certificates, uninstall them from the cloud server, or limit\nthe number of devices they can auto-register.\n\nThe created signer certificate is compatible with ATECC508A certificate\ncompression.\n\nParameters:\n\n* `validity_years` - how many years is this signer certificate valid","ref":"ATECC508A.Certificate.html#new_signer/1"},{"type":"function","title":"ATECC508A.Certificate.public_key_to_raw/1","doc":"Return the raw public key bits from one in X509 form.","ref":"ATECC508A.Certificate.html#public_key_to_raw/1"},{"type":"function","title":"ATECC508A.Certificate.raw_to_public_key/1","doc":"Convert a raw public key bits to an X509 public key.","ref":"ATECC508A.Certificate.html#raw_to_public_key/1"},{"type":"function","title":"ATECC508A.Certificate.signature/1","doc":"","ref":"ATECC508A.Certificate.html#signature/1"},{"type":"module","title":"ATECC508A.Certificate.Compressed","doc":"An ATECC508A compressed certificate and accompanying information needed to decompress it.\n\nThe fields are:\n\n* `:data` - the compressed certificate data\n* `:device_sn` - if a device serial number is needed to decompress the cert, then this is set\n* `:public_key` - the certificate's public key\n* `:serial_number` - if the compressed certificate uses an arbitrary serial number, then this is it\n* `:subject_rdn` - the subject RDN that should be re-added to the cert when uncompressed\n* `:issuer_rdn` - the issuer's RDN that should be re-added to the cert when uncompressed\n* `:extensions` - the X.509 extensions that should be re-added to the cert when uncompressed\n* `:template` - the template that was use to compress the certificate","ref":"ATECC508A.Certificate.Compressed.html"},{"type":"type","title":"ATECC508A.Certificate.Compressed.t/0","doc":"","ref":"ATECC508A.Certificate.Compressed.html#t:t/0"},{"type":"type","title":"ATECC508A.Certificate.Compressed.template/0","doc":"","ref":"ATECC508A.Certificate.Compressed.html#t:template/0"},{"type":"module","title":"ATECC508A.Certificate.NervesKeyTemplate","doc":"Certificate template for the ATECC508A from Microchip\n\nDetailed information on the certificate compression process can be found here:\nhttp://ww1.microchip.com/downloads/en/Appnotes/20006367A.pdf","ref":"ATECC508A.Certificate.NervesKeyTemplate.html"},{"type":"function","title":"ATECC508A.Certificate.NervesKeyTemplate.device/2","doc":"","ref":"ATECC508A.Certificate.NervesKeyTemplate.html#device/2"},{"type":"function","title":"ATECC508A.Certificate.NervesKeyTemplate.signer/1","doc":"","ref":"ATECC508A.Certificate.NervesKeyTemplate.html#signer/1"},{"type":"type","title":"ATECC508A.Certificate.NervesKeyTemplate.t/0","doc":"","ref":"ATECC508A.Certificate.NervesKeyTemplate.html#t:t/0"},{"type":"module","title":"ATECC508A.Certificate.TrustAndGoTemplate","doc":"Certificate template for pre-provisioned ATECC608B-TNGTLS from Microchip\n(Also known as a Trust and Go provisioned chip)\n\nDetails on the structure of the compressed certificate and how they map to a standard X.509 cert can be found on the datasheet:\nhttps://ww1.microchip.com/downloads/en/DeviceDoc/ATECC608B-TNGTLS-CryptoAuthentication-Data-Sheet-DS40002250A.pdf\n(Table 4-12 - Certificate Storage)\n\nDetailed information on the certificate compression process can be found here:\nhttp://ww1.microchip.com/downloads/en/Appnotes/20006367A.pdf","ref":"ATECC508A.Certificate.TrustAndGoTemplate.html"},{"type":"function","title":"ATECC508A.Certificate.TrustAndGoTemplate.device/6","doc":"","ref":"ATECC508A.Certificate.TrustAndGoTemplate.html#device/6"},{"type":"function","title":"ATECC508A.Certificate.TrustAndGoTemplate.signer/3","doc":"","ref":"ATECC508A.Certificate.TrustAndGoTemplate.html#signer/3"},{"type":"type","title":"ATECC508A.Certificate.TrustAndGoTemplate.aki/0","doc":"","ref":"ATECC508A.Certificate.TrustAndGoTemplate.html#t:aki/0"},{"type":"type","title":"ATECC508A.Certificate.TrustAndGoTemplate.chain_id/0","doc":"","ref":"ATECC508A.Certificate.TrustAndGoTemplate.html#t:chain_id/0"},{"type":"type","title":"ATECC508A.Certificate.TrustAndGoTemplate.signer_id/0","doc":"","ref":"ATECC508A.Certificate.TrustAndGoTemplate.html#t:signer_id/0"},{"type":"type","title":"ATECC508A.Certificate.TrustAndGoTemplate.ski/0","doc":"","ref":"ATECC508A.Certificate.TrustAndGoTemplate.html#t:ski/0"},{"type":"type","title":"ATECC508A.Certificate.TrustAndGoTemplate.t/0","doc":"","ref":"ATECC508A.Certificate.TrustAndGoTemplate.html#t:t/0"},{"type":"type","title":"ATECC508A.Certificate.TrustAndGoTemplate.template_id/0","doc":"","ref":"ATECC508A.Certificate.TrustAndGoTemplate.html#t:template_id/0"},{"type":"module","title":"ATECC508A.Configuration","doc":"This module handles operations on the configuration zone.","ref":"ATECC508A.Configuration.html"},{"type":"function","title":"ATECC508A.Configuration.from_raw/1","doc":"Convert a raw configuration to a nice map.","ref":"ATECC508A.Configuration.html#from_raw/1"},{"type":"function","title":"ATECC508A.Configuration.lock/2","doc":"Lock the configuration zone.\n\nThe expected contents need to be passed for a CRC calculation. They are not\nwritten by design. The logic is that this is a final chance before it's too\nlate to check that the device is programmed correctly.","ref":"ATECC508A.Configuration.html#lock/2"},{"type":"function","title":"ATECC508A.Configuration.read/1","doc":"Read the configuration","ref":"ATECC508A.Configuration.html#read/1"},{"type":"function","title":"ATECC508A.Configuration.read_all_raw/1","doc":"Read the entire contents of the configuration zone and don't interpret them","ref":"ATECC508A.Configuration.html#read_all_raw/1"},{"type":"function","title":"ATECC508A.Configuration.read_key_config/1","doc":"Read the current slot configuration","ref":"ATECC508A.Configuration.html#read_key_config/1"},{"type":"function","title":"ATECC508A.Configuration.read_slot_config/1","doc":"Read the current slot configuration","ref":"ATECC508A.Configuration.html#read_slot_config/1"},{"type":"function","title":"ATECC508A.Configuration.to_raw/1","doc":"Convert a nice config map back to a raw configuration","ref":"ATECC508A.Configuration.html#to_raw/1"},{"type":"function","title":"ATECC508A.Configuration.write/2","doc":"Write the configuration.\n\nThis only works when the ATECC508A is unlocked and only bytes not all bytes can\nbe changed. This only writes the ones that can.","ref":"ATECC508A.Configuration.html#write/2"},{"type":"function","title":"ATECC508A.Configuration.write_key_config/2","doc":"Write the key configuration.","ref":"ATECC508A.Configuration.html#write_key_config/2"},{"type":"function","title":"ATECC508A.Configuration.write_slot_config/2","doc":"Write a slot configuration.","ref":"ATECC508A.Configuration.html#write_slot_config/2"},{"type":"type","title":"ATECC508A.Configuration.t/0","doc":"","ref":"ATECC508A.Configuration.html#t:t/0"},{"type":"module","title":"ATECC508A.DataZone","doc":"This module handles operations on the data zone.","ref":"ATECC508A.DataZone.html"},{"type":"function","title":"ATECC508A.DataZone.lock/2","doc":"Lock the data and OTP zones.\n\nThe expected contents concatenated together for the non-private key data slots and\nthe OTP need to be passed for a CRC calculation. They are not\nwritten by design. The logic is that this is a final chance before it's too\nlate to check that the device is programmed correctly.","ref":"ATECC508A.DataZone.html#lock/2"},{"type":"function","title":"ATECC508A.DataZone.pad_to_32/1","doc":"Pad the passed in data to a multiple of 32-bytes\n\nThis is useful when 4-byte writes aren't allowed.","ref":"ATECC508A.DataZone.html#pad_to_32/1"},{"type":"function","title":"ATECC508A.DataZone.pad_to_slot_size/2","doc":"Pad the specified data to the exact size of the slot.","ref":"ATECC508A.DataZone.html#pad_to_slot_size/2"},{"type":"function","title":"ATECC508A.DataZone.read/2","doc":"Read a slot","ref":"ATECC508A.DataZone.html#read/2"},{"type":"function","title":"ATECC508A.DataZone.slot_size/1","doc":"Return the size in bytes of the specified slot.","ref":"ATECC508A.DataZone.html#slot_size/1"},{"type":"function","title":"ATECC508A.DataZone.write/3","doc":"Write a slot in the data zone.\n\nThis can use 4 byte writes if the data is not a multiple of 32 bytes. These\nare only allowed under some conditions.  Most notably, 4-byte writes aren't\nallowed when the data zone is UNLOCKED.","ref":"ATECC508A.DataZone.html#write/3"},{"type":"function","title":"ATECC508A.DataZone.write_padded/3","doc":"Write a slot in the data zone and pad to a multiple of 32-bytes\n\nThis is useful to get around 32-byte write limitations. The padded bytes are\nset to 0.","ref":"ATECC508A.DataZone.html#write_padded/3"},{"type":"module","title":"ATECC508A.Info","doc":"This struct contains all of the data stored on the device. Depending on how the device has been provisioned (or not),\nsome fields may be nil.","ref":"ATECC508A.Info.html"},{"type":"type","title":"ATECC508A.Info.t/0","doc":"","ref":"ATECC508A.Info.html#t:t/0"},{"type":"module","title":"ATECC508A.OTPZone","doc":"This module handles operations on the OTP zone.","ref":"ATECC508A.OTPZone.html"},{"type":"function","title":"ATECC508A.OTPZone.read/1","doc":"Read the OTP","ref":"ATECC508A.OTPZone.html#read/1"},{"type":"function","title":"ATECC508A.OTPZone.write/2","doc":"Write the configuration.\n\nThis only works when the ATECC508A is unlocked and only bytes not all bytes can\nbe changed. This only writes the ones that can.","ref":"ATECC508A.OTPZone.html#write/2"},{"type":"module","title":"ATECC508A.ProvisioningInfo","doc":"This struct contains all of the data needed to provision a device.","ref":"ATECC508A.ProvisioningInfo.html"},{"type":"type","title":"ATECC508A.ProvisioningInfo.t/0","doc":"","ref":"ATECC508A.ProvisioningInfo.html#t:t/0"},{"type":"module","title":"ATECC508A.Request","doc":"This module knows how to send requests to the ATECC508A.","ref":"ATECC508A.Request.html"},{"type":"function","title":"ATECC508A.Request.ecdh/2","doc":"Calculates ECDH secret.","ref":"ATECC508A.Request.html#ecdh/2"},{"type":"function","title":"ATECC508A.Request.genkey/3","doc":"Create a genkey request message.","ref":"ATECC508A.Request.html#genkey/3"},{"type":"function","title":"ATECC508A.Request.lock_slot/2","doc":"Lock a specific slot.","ref":"ATECC508A.Request.html#lock_slot/2"},{"type":"function","title":"ATECC508A.Request.lock_zone/3","doc":"Create a message to lock a zone.","ref":"ATECC508A.Request.html#lock_zone/3"},{"type":"function","title":"ATECC508A.Request.random/1","doc":"Request a random number.","ref":"ATECC508A.Request.html#random/1"},{"type":"function","title":"ATECC508A.Request.read_zone/4","doc":"Create a read message","ref":"ATECC508A.Request.html#read_zone/4"},{"type":"function","title":"ATECC508A.Request.sign_digest/3","doc":"Sign a SHA256 digest.","ref":"ATECC508A.Request.html#sign_digest/3"},{"type":"function","title":"ATECC508A.Request.to_config_addr/1","doc":"","ref":"ATECC508A.Request.html#to_config_addr/1"},{"type":"function","title":"ATECC508A.Request.to_config_addr/2","doc":"","ref":"ATECC508A.Request.html#to_config_addr/2"},{"type":"function","title":"ATECC508A.Request.to_data_addr/2","doc":"","ref":"ATECC508A.Request.html#to_data_addr/2"},{"type":"function","title":"ATECC508A.Request.to_data_addr/3","doc":"","ref":"ATECC508A.Request.html#to_data_addr/3"},{"type":"function","title":"ATECC508A.Request.to_otp_addr/1","doc":"","ref":"ATECC508A.Request.html#to_otp_addr/1"},{"type":"function","title":"ATECC508A.Request.to_otp_addr/2","doc":"","ref":"ATECC508A.Request.html#to_otp_addr/2"},{"type":"function","title":"ATECC508A.Request.write_zone/4","doc":"Create a write message","ref":"ATECC508A.Request.html#write_zone/4"},{"type":"type","title":"ATECC508A.Request.access_data/0","doc":"","ref":"ATECC508A.Request.html#t:access_data/0"},{"type":"type","title":"ATECC508A.Request.access_size/0","doc":"","ref":"ATECC508A.Request.html#t:access_size/0"},{"type":"type","title":"ATECC508A.Request.addr/0","doc":"","ref":"ATECC508A.Request.html#t:addr/0"},{"type":"type","title":"ATECC508A.Request.block/0","doc":"","ref":"ATECC508A.Request.html#t:block/0"},{"type":"type","title":"ATECC508A.Request.offset/0","doc":"","ref":"ATECC508A.Request.html#t:offset/0"},{"type":"type","title":"ATECC508A.Request.slot/0","doc":"","ref":"ATECC508A.Request.html#t:slot/0"},{"type":"type","title":"ATECC508A.Request.transaction/0","doc":"A transaction is a tuple with the binary to send, how long to\nwait in milliseconds for the response and the size of payload to\nexpect to read for the response.","ref":"ATECC508A.Request.html#t:transaction/0"},{"type":"type","title":"ATECC508A.Request.zone/0","doc":"","ref":"ATECC508A.Request.html#t:zone/0"},{"type":"module","title":"ATECC508A.SerialNumber","doc":"Compute X.509 certificate serial numbers","ref":"ATECC508A.SerialNumber.html"},{"type":"function","title":"ATECC508A.SerialNumber.from_device_sn/2","doc":"Compute a certificate serial number based on the device's\n9-byte serial number and the encoded issue/expire date.\nThis is used for device certificates.\n\nReturns the serial number","ref":"ATECC508A.SerialNumber.html#from_device_sn/2"},{"type":"function","title":"ATECC508A.SerialNumber.from_public_key/2","doc":"Compute a certificate serial number based on the certificate's\npublic key. This can be used for signer certificates.","ref":"ATECC508A.SerialNumber.html#from_public_key/2"},{"type":"behaviour","title":"ATECC508A.Transport","doc":"ATECC508A transport behaviour","ref":"ATECC508A.Transport.html"},{"type":"function","title":"ATECC508A.Transport.detected?/1","doc":"Check whether the ATECC508A is present\n\nThe transport implementation should do the minimum work to figure out whether\nan ATECC508A is actually present. This is called by users who are unsure\nwhether the device has an ATECC508A and want to check before sending requests\nto it.","ref":"ATECC508A.Transport.html#detected?/1"},{"type":"callback","title":"ATECC508A.Transport.detected?/1","doc":"","ref":"ATECC508A.Transport.html#c:detected?/1"},{"type":"function","title":"ATECC508A.Transport.info/1","doc":"Return information about this transport\n\nThis information is specific to this transport. No fields are required.","ref":"ATECC508A.Transport.html#info/1"},{"type":"callback","title":"ATECC508A.Transport.info/1","doc":"","ref":"ATECC508A.Transport.html#c:info/1"},{"type":"callback","title":"ATECC508A.Transport.init/1","doc":"","ref":"ATECC508A.Transport.html#c:init/1"},{"type":"function","title":"ATECC508A.Transport.request/4","doc":"Send a request to the ATECC508A and wait for a response\n\nThis is the raw request. The transport implementation takes care of adding\nand removing CRCs.","ref":"ATECC508A.Transport.html#request/4"},{"type":"callback","title":"ATECC508A.Transport.request/4","doc":"","ref":"ATECC508A.Transport.html#c:request/4"},{"type":"function","title":"ATECC508A.Transport.transaction/2","doc":"Run a callback function inside a transaction that doesn't sleep\n\nUse a transaction when multiple requests need to be sent without putting the\nchip to sleep. For example, when a value needs to be stored in SRAM and then\nacted on, since sleeping will clear the SRAM.\n\n`callback` is a function that provides one argument, `request`, and expects a\nreturn value of `{:ok, data}` or `{:error, reason}`. `request` is an anonymous\nfunction whose args follow the public function `ATECC508A.Transport.request/4`,\nexcept without the first arg (`t()`) since this is provided to `transaction`.\n\nThe success/error tuple returned by the callback function is returned\nby `transaction`.","ref":"ATECC508A.Transport.html#transaction/2"},{"type":"function","title":"Example - ATECC508A.Transport.transaction/2","doc":"```ex\n{:ok, transport} = ATECC508A.Transport.I2C.init()\n\n{:ok, signature} =\n  ATECC508A.Transport.transaction(transport, fn request ->\n    # NONCE command (0x16)\n    {:ok, <<0>>} = request.(<<0x16, 0x43, 0, 0, signature_digest::binary>>, 29, 1)\n    # SIGN command (0x41)\n    request.(<<0x41, 0xA0, 0, 0>>, 115, 64)\n  end)\n```","ref":"ATECC508A.Transport.html#transaction/2-example"},{"type":"callback","title":"ATECC508A.Transport.transaction/2","doc":"","ref":"ATECC508A.Transport.html#c:transaction/2"},{"type":"type","title":"ATECC508A.Transport.t/0","doc":"","ref":"ATECC508A.Transport.html#t:t/0"},{"type":"module","title":"ATECC508A.Transport.Cache","doc":"Simple cache for reducing unnecessary traffic to the ATECC508A","ref":"ATECC508A.Transport.Cache.html"},{"type":"function","title":"ATECC508A.Transport.Cache.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"ATECC508A.Transport.Cache.html#child_spec/1"},{"type":"function","title":"ATECC508A.Transport.Cache.get/2","doc":"Check the cache for the request","ref":"ATECC508A.Transport.Cache.html#get/2"},{"type":"function","title":"ATECC508A.Transport.Cache.put/3","doc":"Selectively cache responses","ref":"ATECC508A.Transport.Cache.html#put/3"},{"type":"function","title":"ATECC508A.Transport.Cache.start_link/0","doc":"","ref":"ATECC508A.Transport.Cache.html#start_link/0"},{"type":"type","title":"ATECC508A.Transport.Cache.response/0","doc":"","ref":"ATECC508A.Transport.Cache.html#t:response/0"},{"type":"module","title":"ATECC508A.Transport.I2C","doc":"Implementation for communicating with ATECC508A parts connected over I2C","ref":"ATECC508A.Transport.I2C.html"},{"type":"function","title":"ATECC508A.Transport.I2C.init/1","doc":"Initialize an I2C transport to an ATECC508A\n\nOptions are:\n\n* `:bus_name` - \"i2c-0\", \"i2c-1\", etc. The default is \"i2c-1\" which frequently\n  works on Raspberry Pis and Beaglebones\n* `:address` - This is the I2C address of the ATECC508A/608A. The default\n  is 0x60. It is not common to change this address in Nerves devices.\n\nIf a transport has already been created to the specified ATECC508A, that\ntransport will be returned. All commands to the ATECC508A are serialized\nso that they don't interfere with each other.","ref":"ATECC508A.Transport.I2C.html#init/1"},{"type":"type","title":"ATECC508A.Transport.I2C.i2c_args/0","doc":"I2C transports are specified by a bus name like \"i2c-1\" and\nan I2C address.","ref":"ATECC508A.Transport.I2C.html#t:i2c_args/0"},{"type":"type","title":"ATECC508A.Transport.I2C.instance/0","doc":"","ref":"ATECC508A.Transport.I2C.html#t:instance/0"},{"type":"module","title":"ATECC508A.Util","doc":"Various utility functions","ref":"ATECC508A.Util.html"},{"type":"function","title":"ATECC508A.Util.pad_zeros/2","doc":"Pad the given binary out to the specified length.","ref":"ATECC508A.Util.html#pad_zeros/2"},{"type":"function","title":"ATECC508A.Util.trim_zeros/1","doc":"Trim trailing zeros from a binary.","ref":"ATECC508A.Util.html#trim_zeros/1"},{"type":"module","title":"ATECC508A.Validity","doc":"Handle the ATECC508's encoded dates","ref":"ATECC508A.Validity.html"},{"type":"function","title":"ATECC508A.Validity.compress/1","doc":"Convenience function for compressing issue date/expiration tuples","ref":"ATECC508A.Validity.html#compress/1"},{"type":"function","title":"ATECC508A.Validity.compress/2","doc":"Compress an issue date/expiration to a bitstring\n\nThis function can easily lose precision on the dates and times since\nso little is encoded. If accepting arbitrary datetimes, you'll want\nto check that the conversion didn't truncate in strange ways.\n\nImportant: the max issue year is 2031!!","ref":"ATECC508A.Validity.html#compress/2"},{"type":"function","title":"ATECC508A.Validity.create_compatible_validity/1","doc":"Create a compatible date range for X.509 certificates that need to be compressed.","ref":"ATECC508A.Validity.html#create_compatible_validity/1"},{"type":"function","title":"ATECC508A.Validity.decompress/1","doc":"Decompress an issue date/expiration bitstring","ref":"ATECC508A.Validity.html#decompress/1"},{"type":"function","title":"ATECC508A.Validity.valid_dates?/2","doc":"Check that the specified dates can be represented in a compressed certificate.","ref":"ATECC508A.Validity.html#valid_dates?/2"},{"type":"extras","title":"ATECC508A","doc":"# ATECC508A\n\n[![CircleCI](https://circleci.com/gh/nerves-hub/atecc508a.svg?style=svg)](https://circleci.com/gh/nerves-hub/atecc508a)\n[![Hex version](https://img.shields.io/hexpm/v/atecc508a.svg \"Hex version\")](https://hex.pm/packages/atecc508a)\n\nThe [ATECC508A Crypto Authentication](https://www.microchip.com/wwwproducts/en/ATECC508A)\n(or the newer ATECC608A) is the main component of the NervesKey. If your device\nneeds to authenticate with NervesHub or another cloud service using client-side\nSSL, this library could be of interest. The higher level\n[NervesKey](https://github.com/nerves-hub/nerves_key) package will likely make\nmore sense and you're recommended to start there.","ref":"readme.html"},{"type":"extras","title":"Installation - ATECC508A","doc":"The package can be installed by adding `atecc508a` to your list of dependencies\nin `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:atecc508a, \"~> 0.3.0\"}\n  ]\nend\n```\n\nDocumentation can be found at [https://hexdocs.pm/atecc508a](https://hexdocs.pm/atecc508a).","ref":"readme.html#installation"},{"type":"extras","title":"Quick start - ATECC508A","doc":"Connect an ATECC508A or ATECC608A to an I2C bus on your device. If this is a new\ndevice, it won't be configured and therefore it can't do much exciting. You can\nstill read the configuration block, though. Here's a walk-through:\n\n```elixir\niex> {:ok, i2c} = ATECC508A.Transport.I2C.init(bus_name: \"i2c-1\")\n{:ok, {ATECC508A.Transport.I2C, {#Reference<0.713213266.268828681.225043>, 96}}}\niex> ATECC508A.Configuration.read(i2c)\n{:ok,\n %ATECC508A.Configuration{\n   chip_mode: 0,\n   counter0: 4294967295,\n   counter1: 4294967295,\n   i2c_address: 192,\n   i2c_enable: 85,\n   key_config: <<51, 0, 51, 0, 51, 0, 28, 0, 28, 0, 28, 0, 28, 0, 28, 0, 60, 0,\n     60, 0, 60, 0, 60, 0, 60, 0, 60, 0, 60, 0, 28, 0>>,\n   last_key_use: <<0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0>>,\n   lock_config: 85,\n   lock_value: 85,\n   otp_mode: 0,\n   reserved0: 193,\n   reserved1: 0,\n   reserved2: 0,\n   rev_num: :ecc608a_1,\n   rfu: <<0, 0>>,\n   selector: 0,\n   serial_number: <<1, 35, 185, 8, 198, 142, 22, 255, 238>>,\n   slot_config: <<131, 32, 135, 32, 143, 32, 196, 143, 143, 143, 143, 143, 159,\n     143, 175, 143, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, ...>>,\n   slot_locked: 65535,\n   user_extra: 0,\n   x509_format: <<0, 0, 0, 0>>\n }}\n```\n\nMost functions in this library end up in `ATECC508A.Request`, but there are many\nmodules that make working with the device easier elsewhere.","ref":"readme.html#quick-start"},{"type":"extras","title":"Device configuration - ATECC508A","doc":"Figuring out how to configure devices is perhaps the most consuming part of\nusing an ATECC508A/ATECC608. Take a look at the device configuration section in\nthe [NervesKey documentation](https://github.com/nerves-hub/nerves_key). That\nconfiguration supports authenticating TLS connections to [Nerves\nHub](https://nerves-hub.org/) and other cloud services. The `NervesKey` library\nalso makes provisioning the chip much easier than using this library directly.\nFor integrating with Erlang's TLS stack, see\n[nerves_key_pkcs11](https://github.com/nerves-hub/nerves_key_pkcs11).","ref":"readme.html#device-configuration"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,48]}}